#include <stdio.h>
#include <unistd.h>

void access_counter(unsigned *hi, unsigned *lo) {


/* rdtsc instruction reads processor's current time stamp counter in EDX:EAX registers
 * two movl instruction then move the register contents into the memory pointed to by hi and lo
 *
 *
 * */
    asm("rdtsc; \
         movl %%edx,%0; \
         movl %%eax,%1"
	: "=r" (*hi), "=r" (*lo)
	:
	: "%edx", "%eax");
}

int
main(int argc, char *argv[])
{
    unsigned hi, lo, hi1, lo1;
    long long unsigned a1, b1;
    float c,g = 1000000;

    access_counter(&hi, &lo);
    printf("hi %u lo %u\n", hi,lo);
    a1 = ((unsigned long long)lo)| (((unsigned long long) hi) << 32);

    sleep(10); 
   
    access_counter(&hi1, &lo1);
    printf("hi %u lo %u\n", hi1, lo1);
    b1 = ((unsigned long long)lo1)| (((unsigned long long) hi1) << 32);

    c = b1-a1;
    printf("diff: %llu\n", c);
    printf("Approx. counter increase every second: %llu\n", c/10);
    printf("In MHz: %f\n", (c/g)/10.0);

    return 0;
}

